AbstractLobCreatingPreparedStatementCallback (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.jdbc.core.support

## Class AbstractLobCreatingPreparedStatementCallback

- java.lang.Object
- - org.springframework.jdbc.core.support.AbstractLobCreatingPreparedStatementCallback

- All Implemented Interfaces:
    PreparedStatementCallback<Integer>

      public abstract class AbstractLobCreatingPreparedStatementCallback
      extends Object
      implements PreparedStatementCallback<Integer>

  Abstract PreparedStatementCallback implementation that manages a LobCreator. Typically used as inner class, with access to surrounding method arguments.

  Delegates to the `setValues` template method for setting values on the PreparedStatement, using a given LobCreator for BLOB/CLOB arguments.

  A usage example with JdbcTemplate:

      JdbcTemplate jdbcTemplate = new JdbcTemplate(dataSource);  // reusable object
       LobHandler lobHandler = new DefaultLobHandler();  // reusable object

       jdbcTemplate.execute(
           "INSERT INTO imagedb (image_name, content, description) VALUES (?, ?, ?)",
           new AbstractLobCreatingPreparedStatementCallback(lobHandler) {
             protected void setValues(PreparedStatement ps, LobCreator lobCreator) throws SQLException {
               ps.setString(1, name);
               lobCreator.setBlobAsBinaryStream(ps, 2, contentStream, contentLength);
               lobCreator.setClobAsString(ps, 3, description);
             }
           }
       );

  Since:
    1.0.2
  Author:
    Juergen Hoeller
  See Also:
    `LobCreator`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractLobCreatingPreparedStatementCallback(LobHandler lobHandler)` Create a new AbstractLobCreatingPreparedStatementCallback for the given LobHandler.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Integer` | `doInPreparedStatement(PreparedStatement ps)` Gets called by `JdbcTemplate.execute` with an active JDBC PreparedStatement.
    `protected abstract void` | `setValues(PreparedStatement ps, LobCreator lobCreator)` Set values on the given PreparedStatement, using the given LobCreator for BLOB/CLOB arguments.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractLobCreatingPreparedStatementCallback

          public AbstractLobCreatingPreparedStatementCallback(LobHandler lobHandler)

      Create a new AbstractLobCreatingPreparedStatementCallback for the given LobHandler.
      Parameters:
        `lobHandler` - the LobHandler to create LobCreators with

  - ### Method Detail

    - #### doInPreparedStatement

          public final Integer doInPreparedStatement(PreparedStatement ps)
                                              throws SQLException,
                                                     DataAccessException

      Description copied from interface: `PreparedStatementCallback`
      Gets called by `JdbcTemplate.execute` with an active JDBC PreparedStatement. Does not need to care about closing the Statement or the Connection, or about handling transactions: this will all be handled by Spring's JdbcTemplate.

      NOTE: Any ResultSets opened should be closed in finally blocks within the callback implementation. Spring will close the Statement object after the callback returned, but this does not necessarily imply that the ResultSet resources will be closed: the Statement objects might get pooled by the connection pool, with `close` calls only returning the object to the pool but not physically closing the resources.

      If called without a thread-bound JDBC transaction (initiated by DataSourceTransactionManager), the code will simply get executed on the JDBC connection with its transactional semantics. If JdbcTemplate is configured to use a JTA-aware DataSource, the JDBC connection and thus the callback code will be transactional if a JTA transaction is active.

      Allows for returning a result object created within the callback, i.e. a domain object or a collection of domain objects. Note that there's special support for single step actions: see JdbcTemplate.queryForObject etc. A thrown RuntimeException is treated as application exception, it gets propagated to the caller of the template.

      Specified by:
        `doInPreparedStatement` in interface `PreparedStatementCallback<Integer>`
      Parameters:
        `ps` - active JDBC PreparedStatement
      Returns:
        a result object, or `null` if none
      Throws:
        `SQLException` - if thrown by a JDBC method, to be auto-converted to a DataAccessException by a SQLExceptionTranslator
        `DataAccessException` - in case of custom exceptions
      See Also:
        `JdbcTemplate.queryForObject(String, Object[], Class)`, `JdbcTemplate.queryForList(String, Object[])`

    - #### setValues

          protected abstract void setValues(PreparedStatement ps,
                       LobCreator lobCreator)
                                     throws SQLException,
                                            DataAccessException

      Set values on the given PreparedStatement, using the given LobCreator for BLOB/CLOB arguments.
      Parameters:
        `ps` - the PreparedStatement to use
        `lobCreator` - the LobCreator to use
      Throws:
        `SQLException` - if thrown by JDBC methods
        `DataAccessException` - in case of custom exceptions